(defproject wanijo "0.1.0-SNAPSHOT"
  :description "FIXME: write description"
  :url "http://example.com/FIXME"
  :min-lein-version "2.0.0"

  :dependencies [;;clojure core
                 [org.clojure/clojure "1.10.0"]

                 ;; static site
                 [compojure "1.6.1"]
                 [ring/ring-defaults "0.3.2"]
                 [ring/ring-jetty-adapter "1.7.1"
                  :exclusions [ring/ring-core
                               ring/ring-codec
                               commons-io
                               commons-codec]]
                 [hiccup "1.0.5"]
                 [joshavg/formulare "0.4.0-SNAPSHOT"]

                 ;; neo4j
                 [gorillalabs/neo4j-clj "2.0.1"
                  :exclusions [org.bouncycastle/bcprov-jdk15on
                               org.bouncycastle/bcpkix-jdk15on
                               com.github.ben-manes.caffeine/caffeine]]

                 ;; additional server side libs
                 [buddy/buddy-hashers "1.3.0"
                  :exclusions [commons-codec]]
                 [clj-time "0.15.1"]
                 [markdown-clj "1.0.7"]
                 [dorothy "0.0.7"]

                 ;; fancy js fuckup
                 [org.clojure/clojurescript "1.10.520"]
                 [reagent "0.8.1"]]

  :profiles {:dev {:dependencies [;; webserver stuff
                                  [javax.servlet/servlet-api "2.5"]
                                  [ring/ring-mock "0.3.2"]
                                  [ring/ring-devel "1.7.1"
                                   :exclusions [ring/ring-core
                                                ring/ring-codec
                                                commons-io
                                                commons-codec]]

                                  ;; fancy js fuckup
                                  [binaryage/devtools "0.9.10"]
                                  [figwheel-sidecar "0.5.18"]
                                  [nrepl "0.6.0"]
                                  [cider/piggieback "0.4.0"]]
                   :plugins [;; neo4j db
                             [joshavg/lein-neo4j "0.4.0"]

                             ;; webserver stuff
                             [lein-less "1.7.5"]
                             [lein-ring "0.12.5"]

                             ;; code quality
                             [lein-ancient "LATEST"]
                             [jonase/eastwood "LATEST"]
                             [lein-bikeshed "0.5.1"]
                             [lein-cloverage "1.0.13"]
                             [cider/cider-nrepl "LATEST"]
                             [lein-kibit "LATEST"]

                             ;; fancy js fuckup
                             [lein-cljsbuild "1.1.7"]
                             [lein-figwheel "0.5.18"]]
                   :source-paths ["src" "env/dev/clj"]}
             :uberjar {:aot :all
                       :main wanijo.main}}

  :neo4j {:path "neo4j"}
  :repl-options {:init-ns wanijo.framework.repl}
  :ring {:handler wanijo.handler/app}
  :less {:source-paths ["resources/app/stylesheets"]
         :target-path "resources/public/css"}
  :hiera {:cluster-depth 2}
  :eastwood {:namespaces [:source-paths]}

  :aliases {"package" ["do"
                       "clean"
                       ["cljsbuild" "once" "release"]
                       ["less" "once"]]}

  ;;fancy js fuckup
  :clean-targets ^{:protect false}
  [:target-path
   [:cljsbuild :builds :app :compiler :output-dir]
   [:cljsbuild :builds :app :compiler :output-to]]
  :figwheel {;;:http-server-root "resources"
             :nrepl-port 7002
             :nrepl-middleware [cider.piggieback/wrap-cljs-repl]
             :css-dirs ["resources/public/css"]

             :ring-handler wanijo.handler/app}
  :cljsbuild {:builds
              {:app
               {:source-paths ["src" "env/dev/cljs"]
                :compiler {:main "wanijo.frontend.dev"
                           :output-to "resources/public/js/app.js"
                           :output-dir "resources/public/js/out"
                           :asset-path "/js/out"
                           :source-map true
                           :optimizations :none
                           :pretty-print true}
                :figwheel {:on-jsload "wanijo.frontend.core/mount-root"
                           :open-urls ["http://localhost:3449/index.html"]}}
               :release
               {:source-paths ["src" "env/prod/cljs"]
                :compiler {:output-to "resources/public/js/app.js"
                           :output-dir "resources/public/js/out-release"
                           :optimizations :advanced
                           :infer-externs true
                           :pretty-print false}}}})
